diff --git a/boot/bootdata/hivesys.inf b/boot/bootdata/hivesys.inf
index 28b89e2c115..55a34e230c9 100644
--- a/boot/bootdata/hivesys.inf
+++ b/boot/bootdata/hivesys.inf
@@ -23,6 +23,12 @@ HKLM,"SYSTEM\CurrentControlSet\Control\CriticalDeviceDatabase\PCI#CC_0604","Clas
 HKLM,"SYSTEM\CurrentControlSet\Control\CriticalDeviceDatabase\*PNP0C08","Service",0x00000000,"acpi"
 HKLM,"SYSTEM\CurrentControlSet\Control\CriticalDeviceDatabase\*PNP0C08","ClassGUID",0x00000000,"{4D36E97D-E325-11CE-BFC1-08002BE10318}"
 
+HKLM,"SYSTEM\CurrentControlSet\Control\CriticalDeviceDatabase\PCI#CC_0101","Service",0x00000000,"pciide"
+HKLM,"SYSTEM\CurrentControlSet\Control\CriticalDeviceDatabase\PCI#CC_0101","ClassGUID",0x00000000,"{4D36E96A-E325-11CE-BFC1-08002BE10318}"
+
+HKLM,"SYSTEM\CurrentControlSet\Control\CriticalDeviceDatabase\*PNP0600","Service",0x00000000,"atapi"
+HKLM,"SYSTEM\CurrentControlSet\Control\CriticalDeviceDatabase\*PNP0600","ClassGUID",0x00000000,"{4D36E96A-E325-11CE-BFC1-08002BE10318}"
+
 HKLM,"SYSTEM\CurrentControlSet\Control\CriticalDeviceDatabase\PCI#CC_0C0300","Service",0x00000000,"usbuhci"
 HKLM,"SYSTEM\CurrentControlSet\Control\CriticalDeviceDatabase\PCI#CC_0C0300","ClassGUID",0x00000000,"{36FC9E60-C465-11CF-8056-444553540000}"
 
@@ -407,6 +413,11 @@ HKLM,"SYSTEM\CurrentControlSet\Control\Class\{9D6D66A6-0B0C-4563-9077-A0E9A7955A
 HKLM,"SYSTEM\CurrentControlSet\Control\Class\{9D6D66A6-0B0C-4563-9077-A0E9A7955AE4}","Class",0x00000000,"Ramdisk"
 HKLM,"SYSTEM\CurrentControlSet\Control\Class\{9D6D66A6-0B0C-4563-9077-A0E9A7955AE4}","Icon",0x00000000,"-5"
 
+HKLM,"SYSTEM\CurrentControlSet\Control\Class\{4D36E96A-E325-11CE-BFC1-08002BE10318}",,0x00000000,"IDE ATA/ATAPI controllers"
+HKLM,"SYSTEM\CurrentControlSet\Control\Class\{4D36E96A-E325-11CE-BFC1-08002BE10318}","Class",0x00000000,"hdc"
+HKLM,"SYSTEM\CurrentControlSet\Control\Class\{4D36E96A-E325-11CE-BFC1-08002BE10318}","Icon",0x00000000,"-9"
+HKLM,"SYSTEM\CurrentControlSet\Control\Class\{4D36E96A-E325-11CE-BFC1-08002BE10318}","Installer32",0x00000000,"SysSetup.Dll,HdcClassInstaller"
+
 ; Class Co-Installers
 HKLM,"SYSTEM\CurrentControlSet\Control\CoDeviceInstallers",,0x00000012
 HKLM,"SYSTEM\CurrentControlSet\Control\CoDeviceInstallers","{4D36E965-E325-11CE-BFC1-08002BE10318}",0x00010000,"syssetup.dll,StorageCoInstaller","syssetup.dll,CriticalDeviceCoInstaller"
diff --git a/boot/bootdata/txtsetup.sif b/boot/bootdata/txtsetup.sif
index 6e2c3f69452..312f12d2820 100644
--- a/boot/bootdata/txtsetup.sif
+++ b/boot/bootdata/txtsetup.sif
@@ -90,7 +90,7 @@ FreeSysPartDiskSpace=450
 acpi.sys     = 1,,,,,,,4,1,,,1,4
 nmidebug.sys = 1,,,,,,x,4,,,,1,4
 sacdrv.sys   = 1,,,,,,x,4,,,,1,4
-uniata.sys   = 1,,,,,,x,4,,,,1,4
+atapi.sys   = 1,,,,,,x,4,,,,1,4
 buslogic.sys = 1,,,,,,x,4,,,,1,4
 blue.sys     = 1,,,,,,x,4,,,,1,4
 vgafonts.cab = 1,,,,,,,1,,,,1,1
@@ -156,11 +156,8 @@ PCI\CC_0601 = isapnp
 PCI\CC_0604 = pci
 PCI\VEN_104B&CC_0100 = buslogic
 PCI\CC_0101 = pciide
-PCI\CC_0104 = uniata
-PCI\CC_0105 = uniata
-PCI\CC_0106 = uniata
 ;PCI\CC_0106 = storahci
-*PNP0600 = uniata
+*PNP0600 = atapi
 USB\CLASS_09 = usbhub
 USB\ROOT_HUB = usbhub
 USB\ROOT_HUB20 = usbhub
@@ -199,7 +196,7 @@ i8042prt = i8042prt.sys
 pciide = pciide.sys
 
 [SCSI.Load]
-uniata = uniata.sys
+atapi = atapi.sys
 buslogic = buslogic.sys
 storahci = storahci.sys
 disk = disk.sys
diff --git a/drivers/storage/ide/CMakeLists.txt b/drivers/storage/ide/CMakeLists.txt
index f49c4ce8bf3..491c9a040f8 100644
--- a/drivers/storage/ide/CMakeLists.txt
+++ b/drivers/storage/ide/CMakeLists.txt
@@ -2,4 +2,4 @@
 add_subdirectory(atapi)
 add_subdirectory(pciide)
 add_subdirectory(pciidex)
-add_subdirectory(uniata)
+# add_subdirectory(uniata)
diff --git a/drivers/storage/ide/atapi/CMakeLists.txt b/drivers/storage/ide/atapi/CMakeLists.txt
index 5ab339c5299..58cc433de83 100644
--- a/drivers/storage/ide/atapi/CMakeLists.txt
+++ b/drivers/storage/ide/atapi/CMakeLists.txt
@@ -4,3 +4,4 @@ target_link_libraries(atapi libcntpr)
 set_module_type(atapi kernelmodedriver)
 add_importlibs(atapi scsiport)
 add_cd_file(TARGET atapi DESTINATION reactos/system32/drivers NO_CAB FOR all)
+add_registry_inf(atapi_reg.inf)
diff --git a/drivers/storage/ide/atapi/atapi_reg.inf b/drivers/storage/ide/atapi/atapi_reg.inf
new file mode 100644
index 00000000000..6851a8840dd
--- /dev/null
+++ b/drivers/storage/ide/atapi/atapi_reg.inf
@@ -0,0 +1,8 @@
+; IDE Port Driver
+[AddReg]
+HKLM,"SYSTEM\CurrentControlSet\Services\atapi","ErrorControl",0x00010001,0x00000003
+HKLM,"SYSTEM\CurrentControlSet\Services\atapi","Group",0x00000000,"SCSI Miniport"
+HKLM,"SYSTEM\CurrentControlSet\Services\atapi","ImagePath",0x00020000,"system32\drivers\atapi.sys"
+HKLM,"SYSTEM\CurrentControlSet\Services\atapi","Start",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\atapi","Type",0x00010001,0x00000001
+HKLM,"SYSTEM\CurrentControlSet\Services\atapi","Tag",0x00010001,0x00000021
diff --git a/drivers/storage/ide/pciide/CMakeLists.txt b/drivers/storage/ide/pciide/CMakeLists.txt
index 863f37cca6f..a00dafb1d97 100644
--- a/drivers/storage/ide/pciide/CMakeLists.txt
+++ b/drivers/storage/ide/pciide/CMakeLists.txt
@@ -11,3 +11,4 @@ else()
 endif()
 add_importlibs(pciide pciidex ntoskrnl)
 add_cd_file(TARGET pciide DESTINATION reactos/system32/drivers NO_CAB FOR all)
+add_registry_inf(pciide_reg.inf)
diff --git a/drivers/storage/ide/pciide/pciide_reg.inf b/drivers/storage/ide/pciide/pciide_reg.inf
new file mode 100644
index 00000000000..c8d83231967
--- /dev/null
+++ b/drivers/storage/ide/pciide/pciide_reg.inf
@@ -0,0 +1,8 @@
+; PCIIde IDE Minidriver
+[AddReg]
+HKLM,"SYSTEM\CurrentControlSet\Services\PCIIde","ErrorControl",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\PCIIde","Group",0x00000000,"System Bus Extender"
+HKLM,"SYSTEM\CurrentControlSet\Services\PCIIde","ImagePath",0x00020000,"system32\drivers\pciide.sys"
+HKLM,"SYSTEM\CurrentControlSet\Services\PCIIde","Start",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\PCIIde","Type",0x00010001,0x00000001
+HKLM,"SYSTEM\CurrentControlSet\Services\PCIIde","Tag",0x00010001,0x00000010