diff --git a/boot/freeldr/freeldr/arch/i386/ntoskrnl.c b/boot/freeldr/freeldr/arch/i386/ntoskrnl.c
index 4255e5cf0e0..08a0a704931 100644
--- a/boot/freeldr/freeldr/arch/i386/ntoskrnl.c
+++ b/boot/freeldr/freeldr/arch/i386/ntoskrnl.c
@@ -28,14 +28,14 @@ FASTCALL
 KefAcquireSpinLockAtDpcLevel(
     IN PKSPIN_LOCK SpinLock)
 {
-#if DBG
-    /* To be on par with HAL/NTOSKRNL */
-#ifdef _M_AMD64
-    *SpinLock = (KSPIN_LOCK)KeGetCurrentThread() | 1;
-#else
-    *SpinLock = (KSPIN_LOCK)(((PKIPCR)KeGetPcr())->PrcbData.CurrentThread) | 1;
-#endif
-#endif
+//#if DBG
+//    /* To be on par with HAL/NTOSKRNL */
+//#ifdef _M_AMD64
+//    *SpinLock = (KSPIN_LOCK)KeGetCurrentThread() | 1;
+//#else
+//    *SpinLock = (KSPIN_LOCK)(((PKIPCR)KeGetPcr())->PrcbData.CurrentThread) | 1;
+//#endif
+//#endif
 }
 
 VOID
diff --git a/ntoskrnl/include/internal/spinlock.h b/ntoskrnl/include/internal/spinlock.h
index 013ad913c34..80445621f77 100644
--- a/ntoskrnl/include/internal/spinlock.h
+++ b/ntoskrnl/include/internal/spinlock.h
@@ -6,25 +6,60 @@
 * PROGRAMMERS:     Alex Ionescu (alex.ionescu@reactos.org)
 */
 
-#if defined(_M_IX86)
+//#if defined(_M_IX86)
 VOID
 NTAPI
 Kii386SpinOnSpinLock(PKSPIN_LOCK SpinLock, ULONG Flags);
-#endif
+
+#ifndef CONFIG_SMP
 
 //
-// Spinlock Acquisition at IRQL >= DISPATCH_LEVEL
+// Spinlock Acquire at IRQL >= DISPATCH_LEVEL
+//
+FORCEINLINE
+VOID
+KxAcquireSpinLock(IN PKSPIN_LOCK SpinLock)
+{
+    /* On UP builds, spinlocks don't exist at IRQL >= DISPATCH */
+        UNREFERENCED_PARAMETER(SpinLock);
+        
+    /* Add an explicit memory barrier to prevent the compiler from reordering
+       memory accesses across the borders of spinlocks */
+           KeMemoryBarrierWithoutFence();
+}
+
+//
+// Spinlock Release at IRQL >= DISPATCH_LEVEL
 //
-_Acquires_nonreentrant_lock_(SpinLock)
 FORCEINLINE
 VOID
-KxAcquireSpinLock(
-#if defined(CONFIG_SMP) || DBG
-    _Inout_
+KxReleaseSpinLock(IN PKSPIN_LOCK SpinLock)
+{
+    /* On UP builds, spinlocks don't exist at IRQL >= DISPATCH */
+        UNREFERENCED_PARAMETER(SpinLock);
+
+    /* Add an explicit memory barrier to prevent the compiler from reordering
+       memory accesses across the borders of spinlocks */
+    KeMemoryBarrierWithoutFence();
+}
+
 #else
-    _Unreferenced_parameter_
-#endif
-    PKSPIN_LOCK SpinLock)
+//#endif
+
+//
+// Spinlock Acquisition at IRQL >= DISPATCH_LEVEL
+//
+//_Acquires_nonreentrant_lock_(SpinLock)
+FORCEINLINE
+VOID
+KxAcquireSpinLock(IN PKSPIN_LOCK SpinLock)
+//KxAcquireSpinLock(
+//#if defined(CONFIG_SMP) || DBG
+//    _Inout_
+//#else
+//    _Unreferenced_parameter_
+//#endif
+//    PKSPIN_LOCK SpinLock)
 {
 #if DBG
     /* Make sure that we don't own the lock already */
@@ -35,7 +70,7 @@ KxAcquireSpinLock(
     }
 #endif
 
-#ifdef CONFIG_SMP
+//#ifdef CONFIG_SMP
     /* Try to acquire the lock */
     while (InterlockedBitTestAndSet((PLONG)SpinLock, 0))
     {
@@ -51,12 +86,12 @@ KxAcquireSpinLock(
         }
 #endif
     }
-#endif
-
-    /* Add an explicit memory barrier to prevent the compiler from reordering
-       memory accesses across the borders of spinlocks */
-    KeMemoryBarrierWithoutFence();
-
+//#endif
+//
+//    /* Add an explicit memory barrier to prevent the compiler from reordering
+//       memory accesses across the borders of spinlocks */
+//    KeMemoryBarrierWithoutFence();
+//
 #if DBG
     /* On debug builds, we OR in the KTHREAD */
     *SpinLock = (KSPIN_LOCK)KeGetCurrentThread() | 1;
@@ -66,16 +101,17 @@ KxAcquireSpinLock(
 //
 // Spinlock Release at IRQL >= DISPATCH_LEVEL
 //
-_Releases_nonreentrant_lock_(SpinLock)
+//_Releases_nonreentrant_lock_(SpinLock)
 FORCEINLINE
 VOID
-KxReleaseSpinLock(
-#if defined(CONFIG_SMP) || DBG
-    _Inout_
-#else
-    _Unreferenced_parameter_
-#endif
-    PKSPIN_LOCK SpinLock)
+KxReleaseSpinLock(IN PKSPIN_LOCK SpinLock)
+//KxReleaseSpinLock(
+//#if defined(CONFIG_SMP) || DBG
+//    _Inout_
+//#else
+//    _Unreferenced_parameter_
+//#endif
+//    PKSPIN_LOCK SpinLock)
 {
 #if DBG
     /* Make sure that the threads match */
@@ -85,17 +121,19 @@ KxReleaseSpinLock(
         KeBugCheckEx(SPIN_LOCK_NOT_OWNED, (ULONG_PTR)SpinLock, 0, 0, 0);
     }
 #endif
-
-#if defined(CONFIG_SMP) || DBG
-    /* Clear the lock  */
+//
+//#if defined(CONFIG_SMP) || DBG
+//    /* Clear the lock  */
 #ifdef _WIN64
     InterlockedAnd64((PLONG64)SpinLock, 0);
 #else
     InterlockedAnd((PLONG)SpinLock, 0);
 #endif
-#endif
-
-    /* Add an explicit memory barrier to prevent the compiler from reordering
-       memory accesses across the borders of spinlocks */
-    KeMemoryBarrierWithoutFence();
 }
+
+#endif
+//
+//    /* Add an explicit memory barrier to prevent the compiler from reordering
+//       memory accesses across the borders of spinlocks */
+//    KeMemoryBarrierWithoutFence();
+//}
diff --git a/ntoskrnl/ke/spinlock.c b/ntoskrnl/ke/spinlock.c
index d382cbf5055..4d39166a336 100644
--- a/ntoskrnl/ke/spinlock.c
+++ b/ntoskrnl/ke/spinlock.c
@@ -112,10 +112,11 @@ KeAcquireQueuedSpinLockAtDpcLevel(_Inout_ PKSPIN_LOCK_QUEUE LockHandle)
                      0,
                      0);
     }
-#endif
+//#endif
 
     /* Do the inlined function */
     KxAcquireSpinLock(LockHandle->Lock);
+#endif
 }
 
 _IRQL_requires_min_(DISPATCH_LEVEL)
@@ -136,10 +137,11 @@ KeReleaseQueuedSpinLockFromDpcLevel(_Inout_ PKSPIN_LOCK_QUEUE LockHandle)
                      0,
                      0);
     }
-#endif
+//#endif
 
     /* Do the inlined function */
     KxReleaseSpinLock(LockHandle->Lock);
+#endif
 }
 
 #endif
@@ -320,12 +322,12 @@ KeTryToAcquireSpinLockAtDpcLevel(IN OUT PKSPIN_LOCK SpinLock)
                      0);
     }
 
-    /* Make sure that we don't own the lock already */
-    if (((KSPIN_LOCK)KeGetCurrentThread() | 1) == *SpinLock)
-    {
-        /* We do, bugcheck! */
-        KeBugCheckEx(SPIN_LOCK_ALREADY_OWNED, (ULONG_PTR)SpinLock, 0, 0, 0);
-    }
+//    /* Make sure that we don't own the lock already */
+//    if (((KSPIN_LOCK)KeGetCurrentThread() | 1) == *SpinLock)
+//    {
+//        /* We do, bugcheck! */
+//        KeBugCheckEx(SPIN_LOCK_ALREADY_OWNED, (ULONG_PTR)SpinLock, 0, 0, 0);
+//    }
 #endif
 
 #ifdef CONFIG_SMP
@@ -344,11 +346,12 @@ KeTryToAcquireSpinLockAtDpcLevel(IN OUT PKSPIN_LOCK SpinLock)
         /* It was already acquired */
         return FALSE;
     }
-#endif
+//#endif
 
 #if DBG
     /* On debug builds, we OR in the KTHREAD */
     *SpinLock = (ULONG_PTR)KeGetCurrentThread() | 1;
+#endif
 #endif
 
     /* All is well, return TRUE */
@@ -363,10 +366,11 @@ FASTCALL
 KeAcquireInStackQueuedSpinLockAtDpcLevel(IN PKSPIN_LOCK SpinLock,
                                          IN PKLOCK_QUEUE_HANDLE LockHandle)
 {
+#ifdef CONFIG_SMP
     /* Set it up properly */
     LockHandle->LockQueue.Next = NULL;
     LockHandle->LockQueue.Lock = SpinLock;
-#ifdef CONFIG_SMP
+//#ifdef CONFIG_SMP
 #if 0
     KeAcquireQueuedSpinLockAtDpcLevel(LockHandle->LockQueue.Next);
 #else
@@ -380,11 +384,13 @@ KeAcquireInStackQueuedSpinLockAtDpcLevel(IN PKSPIN_LOCK SpinLock,
                      0,
                      0);
     }
-#endif
-#endif
+//#endif
+//#endif
 
     /* Acquire the lock */
     KxAcquireSpinLock(LockHandle->LockQueue.Lock); // HACK
+#endif
+#endif
 }
 
 /*
@@ -409,11 +415,13 @@ KeReleaseInStackQueuedSpinLockFromDpcLevel(IN PKLOCK_QUEUE_HANDLE LockHandle)
                      0,
                      0);
     }
-#endif
-#endif
+//#endif
+//#endif
 
     /* Release the lock */
     KxReleaseSpinLock(LockHandle->LockQueue.Lock); // HACK
+#endif
+#endif
 }
 
 /*